import { type ICoordinates, type IOptionLoader, type RecursivePartial } from "tsparticles-engine";
import type { PolygonMaskInlineArrangement, PolygonMaskInlineArrangementAlt } from "../../Enums/PolygonMaskInlineArrangement";
import type { IPolygonMask } from "../Interfaces/IPolygonMask";
import { PolygonMaskDraw } from "./PolygonMaskDraw";
import { PolygonMaskInline } from "./PolygonMaskInline";
import { PolygonMaskLocalSvg } from "./PolygonMaskLocalSvg";
import { PolygonMaskMove } from "./PolygonMaskMove";
import { PolygonMaskType } from "../../Enums/PolygonMaskType";
export declare class PolygonMask implements IPolygonMask, IOptionLoader<IPolygonMask> {
    data?: string | PolygonMaskLocalSvg;
    draw: PolygonMaskDraw;
    enable: boolean;
    inline: PolygonMaskInline;
    move: PolygonMaskMove;
    position?: ICoordinates;
    scale: number;
    type: PolygonMaskType;
    url?: string;
    constructor();
    get inlineArrangement(): PolygonMaskInlineArrangement | keyof typeof PolygonMaskInlineArrangement | PolygonMaskInlineArrangementAlt;
    set inlineArrangement(value: PolygonMaskInlineArrangement | keyof typeof PolygonMaskInlineArrangement | PolygonMaskInlineArrangementAlt);
    load(data?: RecursivePartial<IPolygonMask>): void;
}
