(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PolygonMaskDrawStroke = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    class PolygonMaskDrawStroke {
        constructor() {
            this.color = new tsparticles_engine_1.OptionsColor();
            this.width = 0.5;
            this.opacity = 1;
        }
        load(data) {
            if (!data) {
                return;
            }
            this.color = tsparticles_engine_1.OptionsColor.create(this.color, data.color);
            if ((0, tsparticles_engine_1.isString)(this.color.value)) {
                this.opacity = (0, tsparticles_engine_1.stringToAlpha)(this.color.value) ?? this.opacity;
            }
            if (data.opacity !== undefined) {
                this.opacity = data.opacity;
            }
            if (data.width !== undefined) {
                this.width = data.width;
            }
        }
    }
    exports.PolygonMaskDrawStroke = PolygonMaskDrawStroke;
});
